import socket
import ssl


class login:
    """
    result: "k": b64_encrypted_key, "s": b64_key_salt

    special case:
    result: "r": -1, p: queue_position
    """
    task_number = 1
    default_task_parameters = [0]


class register:
    task_number = 2
    default_task_parameters = [0]


class logout:
    task_number = 3
    default_task_parameters = [0]


class memory:
    """
    --- task parameters ---
    [0] | [0, 0] -> the server will return all labels not updated since given time_point
        parameters:
            key: key_of_usr
            since: time_point -> int
        result:
            "r": ret_val -> int,
            "l": list_of_all_b64_encrypted_labels -> list(String)
    [0, 0, 1] -> the server will return all labels of memory tasks
        parameters: key: key_of_usr
        result:
            "r": ret_val -> int,
            "l": list_of_all_b64_encrypted_labels -> list(String)
    [0, 1] -> The client asks for information about a memory task.
        parameters: key, enc_label
        result:
            "r": ret_val -> int
            "d": deleted -> bool
            "a": active -> Option<bool, if deleted == false>
            "m": b64_encrypted_msg -> Option<String, if deleted == false>
            "ms": b64_msg_salt -> Option<String, if deleted == false>
            "rp": repeat -> Option<bool, if deleted == false>
            "t": b64_encrypted_time_point -> Option<String, if deleted == false && repeat == false>
            "ts": b64_time_point_salt -> Option<String, if deleted == false && repeat == false>
            "s1": b64_encrypted_start_point -> Option<String, if deleted == false && repeat == true>
            "s1s": b64_start_point_salt -> Option<String, if deleted == false && repeat == true>
            "s2": b64_encrypted_stop_point -> Option<String, if deleted == false && repeat == true>
            "s2s": b64_stop_point_salt -> Option<String, if deleted == false && repeat == true>
            "f": b64_encrypted_frequence -> Option<String, if deleted == false && repeat == true>
            "fs": b64_frequence_salt -> Option<String, if deleted == false && repeat == true>
    [1] -> sending new task
        parameters: 
            key
            label
            msg,
            Option<receiver>
            repeat
            Option<time_point, if repeat == false>
            Option<start_point, if repeat == true>
            Option<stop_point, if repeat == true>
            Option<frequence, if repeat == true>
        result:
            "r": ret_val -> int
    [2] -> editing task
        parameters:
            key
            label
            msg,
            Option<receiver>
            repeat
            Option<time_point, if repeat == false>
            Option<start_point, if repeat == true>
            Option<stop_point, if repeat == true>
            Option<frequence, if repeat == true>
        result:
            "r": ret_val -> int
    [3] -> deleting task
        parameters:
            label
        result:
            "r": ret_val -> int
    """

    task_number = 4

    default_task_parameters = [0]


class login_token:
    # --- task parameters ---
    # [0] login with token
        # parameters: token
        # result format: {"r": result, "k" key}
    # [1] asking for new token
        # parameters: (token) -> token means hear the old token as an optional argument. If it is set, the old token will get deleted
    # [2] delete token
        # parameters: token
    # [3] delete all tokens
        # parameters: None
    
    task_number = 5

    login_task_parameters = [0]
    get_new_token_task_parameters = [1]
    delete_token_task_parameters = [2]
    delete_all_tokens_task_parameters = [3]

    default_task_parameters = login_task_parameters